/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMPREBASE                                              */
/* Tabela : ITEMPREBASE                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 17/03/2004 - Raphael Freitas Pinheiro                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ITEMPREBASE
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMPREBASE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUIPRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRECOBASE,0)  <> NVL(:NEW.CDPRECOBASE,0)) OR
         (NVL(:OLD.DTINIVALIPB,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTINIVALIPB,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.DTFIMVALIPB,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTFIMVALIPB,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.CDPRODUTO,0)    <> NVL(:NEW.CDPRODUTO,0))    OR
         (NVL(:OLD.VRITEPREBASE,0) <> NVL(:NEW.VRITEPREBASE,0)) OR
         (NVL(:OLD.DTHRATZIPB,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTHRATZIPB,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.CDOPERATZIPB,0) <> NVL(:NEW.CDOPERATZIPB,0)) THEN
         :NEW.DTULTATUIPRE := SYSDATE;
         UPDATE PRODWEBSYNC
            SET IDATUALIZADO = 'N', DTULTALTPROD = SYSDATE
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ITEMPREBASE', '', 'CDPRECOBASE='||:OLD.CDPRECOBASE||';DTINIVALIPB='||TO_CHAR(:OLD.DTINIVALIPB,'YYYYMMDDHH24MISS')||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ITEMPREBASE MODIFY DTULTATUIPRE DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ITEMPREBASE','4.07.022'); END;
/

