/******************************************************************************/
/* SITE - Sistemas Integrados TECNISA                                         */
/******************************************************************************/
/* Nome: 8650_VMNSTP_GeraMapa                                                 */
/*                                                                            */
/* Descrio:                                                                 */
/*  Gera o Mapa de Abastecimento.                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 07/05/2002 - LUCIANA CORREA                                                */
/******************************************************************************/
/* EXEC GERA_MAPA ('9999','0000000113','0000000113','0000000113','01/04/2002','01/05/2002', '','','','','T','T','T','T', :A,:B,:C,:D) */
/* raise_application_error(-20501, '' , True);                                */
/* @C:\WEB_405\Sql\End_Conv\Oracle\8655_VMNSTPO_GERA_MAPA.SQL                 */
/* DBMS_OUTPUT.PUT_LINE('INSERT INTO ITEMAPABASEV')                           */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE GERA_MAPA(
    P_CDFILIPROC   IN  MAPABASEV.CDFILIAL%TYPE     ,
    P_NRMAPABASEV  IN  MAPABASEV.NRMAPABASEV%TYPE  ,
    P_NRPREVABASEV IN  PREVABASEV.NRPREVABASEV%TYPE,
    P_NRSOLICTROCO IN  SOLICTROCO.NRSOLICTROCO%TYPE,
    P_DTCALEABAS   IN  CALEABAS.DTCALEABAS%TYPE    ,
    P_CDOPERADOR   IN  OPERADOR.CDOPERADOR%TYPE    ,
    P_CDEQUIPPRO   IN  EQUIPAPROD.CDEQUIPPRO%TYPE  ,
    P_CDROTATRANS  IN  ROTATRANS.CDROTATRANS%TYPE  ,
    P_CDFILIALCLIE IN  FILIAL.CDFILIAL%TYPE        ,
    P_CDCLIENTE    IN  CLIENTE.CDCLIENTE%TYPE      ,
    P_CDMOEDEIRO   IN  MOEDEIRO.CDMOEDEIRO%TYPE    ,
    P_IDOCOSANGRIA IN  CALEABAS.IDOCOSANGRIA%TYPE  ,
    P_CDFITABEPREC IN  FILIAL.CDFILIAL%TYPE        ,
    P_CDTABEPREC   IN  TABEPREC.CDTABEPREC%TYPE    ,
    P_IDTPPGTOEQUI IN  EQUIPAPROD.IDTPPGTOEQUI%TYPE,
    P_MSGCODIGO    OUT VARCHAR2                    ,
    P_MSGPRODUTO   OUT VARCHAR2
    )
AS
   V_CDMOEDEIRO   VARCHAR2(03);
   V_NRPREVABASEV VARCHAR2(10);
   V_EXISTE_MAPA  INTEGER     ;
   V_EXISTE_VENDA INTEGER     ;
   V_EXISTE       INTEGER     ;
   V_EXISTE_PREV  NUMBER      ;
   V_EXISTE_PARAM INTEGER     ;
   V_EXISTE_MOLA  INTEGER     ;
   V_EXISTE_PROD  INTEGER     ;
   V_VRPRCLITEM   NUMBER      ;
   V_VRPRCLITEMCL NUMBER      ;
   V_QTPREV       NUMBER      ;
   V_CONTPREV     NUMBER      ;
   V_CONTITEMAPA  NUMBER      ;
   V_VRPRITEMMAP  NUMBER      ;
   V_VRPRITEMCMAP NUMBER      ;
   V_IDSITMAPABAS VARCHAR2(01);
   V_IDSITGABABAS VARCHAR2(01);
   V_IDSITTROABAS VARCHAR2(01);
   V_IDSITSANABAS VARCHAR2(01);
   V_POSSUIPRECO  VARCHAR2(01);
   V_IDSITABASTEC VARCHAR2(01);
   V_IDTIPFILIVMN VARCHAR2(01);
   V_CDPERIENTEN  VARCHAR2(03);
   V_IDTPAPUMAPA  VARCHAR2(01);
   V_QTFREPITMAPA NUMBER;
   V_IDAGRUPPLANO VARCHAR2(01);
   V_CDPRODUTO    PRODUTO.CDPRODUTO%TYPE;
   V_CDITEQUIPPRO ITEQUIPPRO.CDITEQUIPPRO%TYPE;
   V_QTMAXPROITEP ITEQUIPPRO.QTMAXPROITEP%TYPE;
   V_VRPREPITEM   ITEQUIPPRO.VRPREPITEM%TYPE;
   V_VRPREPITEMCL ITEQUIPPRO.VRPREPITEMCL%TYPE;
   V_DTINVIGCNFEP CONFEQUIPPRO.DTINVIGCNFEP%TYPE;
   V_CONTADOR     INTEGER;
   V_INSERE_ITEM  VARCHAR2(03);
   V_IDTPLEIVENDA VARCHAR2(01);
   V_DTINIVIATUAL DATE;
   V_CTDIASAGRUP  NUMBER;

   CURSOR C_ITEMMAPA_1 IS
   SELECT CDPRODUTO, CDITEQUIPPRO,
          MAX(QTMAXPROITEP) AS QTMAXPROITEP,
          MAX(VRPREPITEM  ) AS VRPREPITEM,
          MAX(VRPREPITEMCL) AS VRPREPITEMCL
   FROM
     (SELECT CDPRODUTO, CDITEQUIPPRO,
             NVL(QTMAXPROITEP,0) AS QTMAXPROITEP,
             NVL(VRPREPITEM  ,0) AS VRPREPITEM,
             NVL(VRPREPITEMCL,0) AS VRPREPITEMCL
      FROM   ITEQUIPPRO
      WHERE  CDEQUIPPRO   = P_CDEQUIPPRO
        AND  DTINVIGCNFEP = V_DTINVIGCNFEP
      UNION
      SELECT IT.CDPRODUTO, NVL(IE.CDITEQUIPPRO, IT.CDITEQUIPPRO) CDITEQUIPPRO,
             0 AS QTMAXPROITEP,
             0 AS VRPREPITEM,
             0 AS VRPREPITEMCL
      FROM   ITEQUIPPRO IT,
             (SELECT CDPRODUTO, MIN(CDITEQUIPPRO) CDITEQUIPPRO
              FROM ITEQUIPPRO
              WHERE CDEQUIPPRO   = P_CDEQUIPPRO
                AND DTINVIGCNFEP = V_DTINVIGCNFEP
              GROUP BY CDPRODUTO)  IE
      WHERE  IT.CDEQUIPPRO   = P_CDEQUIPPRO
        AND  IT.DTINVIGCNFEP = (SELECT MAX(DTINVIGCNFEP) FROM ITEQUIPPRO IP
                                WHERE IP.CDEQUIPPRO   = P_CDEQUIPPRO
                                  AND IP.DTINVIGCNFEP < V_DTINVIGCNFEP)
        AND  IT.CDPRODUTO    = IE.CDPRODUTO (+))
   GROUP BY CDPRODUTO, CDITEQUIPPRO;

   CURSOR C_ITEMMAPA_2 IS
   SELECT CDPRODUTO, CDITEQUIPPRO,
          NVL(QTMAXPROITEP,0) AS QTMAXPROITEP,
          NVL(VRPREPITEM  ,0) AS VRPREPITEM,
          NVL(VRPREPITEMCL,0) AS VRPREPITEMCL
   FROM   ITEQUIPPRO
   WHERE  CDEQUIPPRO   = P_CDEQUIPPRO
     AND  DTINVIGCNFEP = V_DTINVIGCNFEP;

BEGIN

   V_QTPREV   := 0;
   V_CONTADOR := 1;

   /* BUSCA NO TIPO DE EQUIPAMENTO SE AGRUPA PLANOGRAMA OU NAO NA GERACAO DO MAPA */
   SELECT NVL(MAX(TE.IDAGRUPPLANO),'X'), MAX(EQ.IDTPLEIVENDA)
   INTO   V_IDAGRUPPLANO, V_IDTPLEIVENDA
   FROM   EQUIPAPROD EQ, TIPOEQUI TE
   WHERE  EQ.CDEQUIPPRO =  P_CDEQUIPPRO
     AND  EQ.CDTIPOEQUI = TE.CDTIPOEQUI(+);

   IF V_IDAGRUPPLANO = 'X' THEN
      P_MSGCODIGO := '7';   /* TIPO DE MQUINA NAO PARAMETRIZADO PARA A MQUINA */
   END IF;

   /* VERIFICA SE EXISTE MAPA GERADO NA DATA PARA O EQUIPAMENTO */
   SELECT COUNT(*)
   INTO   V_EXISTE_MAPA
   FROM   MAPABASEV
   WHERE  DTMAPABASEV = P_DTCALEABAS
     AND  CDEQUIPPRO  = P_CDEQUIPPRO;

   /* VERIFICA SE EXISTE VENDA J GERADA PRA FRENTE */
   SELECT COUNT(*)
   INTO   V_EXISTE_VENDA
   FROM   MAPABASEV MP, VENDAVMN VE
   WHERE  MP.CDFILIAL     = P_CDFILIPROC
     AND  MP.CDEQUIPPRO   = P_CDEQUIPPRO
     AND  MP.CDFILIAL     = VE.CDFILIAL
     AND  MP.NRMAPABASEV  = VE.NRMAPABASEV
     AND  VE.DTVENDAVMN  >= P_DTCALEABAS;

   /* VERIFICA SE EXISTE PARAMETRIZACAO PARA A FILIALCLIE (SITE) */
   SELECT COUNT(*)
   INTO   V_EXISTE_PARAM
   FROM   PARFILIALVMN
   WHERE  CDFILIAL = P_CDFILIALCLIE;

   IF (V_EXISTE_MAPA = 0) AND (V_EXISTE_VENDA = 0) AND (V_EXISTE_PARAM > 0) AND (V_IDAGRUPPLANO <> 'X') THEN

      /* BUSCA O TIPO DE APURACAO DO MAPA PARA A FILIAL DE PROCESSAMENTO  */
      SELECT IDTPAPUMAPA
      INTO   V_IDTPAPUMAPA
      FROM   PARFILIALVMN
      WHERE  CDFILIAL = P_CDFILIPROC;

      /* BUSCA O TIPO DA FILIAL DO CLIENTE */
      SELECT IDTIPFILIVMN
      INTO   V_IDTIPFILIVMN
      FROM   PARFILIALVMN
      WHERE  CDFILIAL = P_CDFILIALCLIE;

      SELECT NVL(MAX(CDPERIENTEN),'NAO')
      INTO   V_CDPERIENTEN
      FROM   ROTATRANS
      WHERE  CDROTATRANS = P_CDROTATRANS;

      V_IDSITMAPABAS := 1; /* MAPA PENDENTE */

      IF (V_CDPERIENTEN = 'NAO') THEN
         V_IDSITABASTEC := 'I'; /* ABASTECIMENTO INEXISTENTE */
      ELSE
         V_IDSITABASTEC := 1; /* ABASTECIMENTO PENDENTE */
      END IF;

      IF P_CDMOEDEIRO <> ' ' THEN
         V_IDSITGABABAS := NULL;  /* GABARITO NAO GERADO */
         V_IDSITTROABAS := NULL;  /* SOL.TROCO NO GERADA */
      ELSE
         V_IDSITGABABAS := 'I';   /* GABARITO INEXISTENTE */
         V_IDSITTROABAS := 'I';  /* SOL.TROCO INEXISTENTE */
      END IF;

      IF (P_IDTPPGTOEQUI = '1') OR (P_IDTPPGTOEQUI = '3') THEN /* A VISTA OU AMBAS */
         V_IDSITSANABAS := '1';  /* SANGRIA PENDENTE */
      ELSE
         V_IDSITSANABAS := 'I';  /* SANGRIA INEXISTENTE */
      END IF;

      INSERT INTO MAPABASEV
        (CDFILIAL      , NRMAPABASEV   , DTMAPABASEV  ,
         CDEQUIPPRO    , CDROTATRANS   , CDCLIENTE    ,
         CDFILIALCLIE  , IDSITMAPABAS  , IDSITGABABAS ,
         IDSITSANABAS  , IDSITTROABAS  , CDOPERABASEV ,
         CDMOEDEIRO    , IDSITABASTEC  , IDTIPFILIMAP )
      VALUES
        (P_CDFILIPROC   , P_NRMAPABASEV  , P_DTCALEABAS  ,
         P_CDEQUIPPRO   , P_CDROTATRANS  , P_CDCLIENTE   ,
         P_CDFILIALCLIE , V_IDSITMAPABAS , V_IDSITGABABAS,
         V_IDSITSANABAS , V_IDSITTROABAS , P_CDOPERADOR  ,
         P_CDMOEDEIRO   , V_IDSITABASTEC , V_IDTIPFILIVMN);

      SELECT MAX(NRPREVABASEV)
      INTO   V_NRPREVABASEV
      FROM   PREVABASEV
      WHERE  CDFILIAL     = P_CDFILIPROC
        AND  DTPREVABASEV = P_DTCALEABAS
        AND  CDROTATRANS  = P_CDROTATRANS
        AND  CDFILIALCLIE = P_CDFILIALCLIE
        AND  NRABASTEROTA IS NULL;

      /*Insere a previso de abastecimento */
      IF V_NRPREVABASEV IS NULL THEN
         V_NRPREVABASEV := P_NRPREVABASEV;
         INSERT INTO PREVABASEV
            (CDFILIAL, NRPREVABASEV, DTPREVABASEV,CDROTATRANS,CDFILIALCLIE,IDTIPPREVABA)
         VALUES
            (P_CDFILIPROC, V_NRPREVABASEV, P_DTCALEABAS,P_CDROTATRANS,P_CDFILIALCLIE,'N');
      END IF;

      V_CONTPREV    := 0;
      V_CONTITEMAPA := 0;

      SELECT MAX(DTINVIGCNFEP) INTO V_DTINVIGCNFEP
      FROM   CONFEQUIPPRO
      WHERE  CDEQUIPPRO   = P_CDEQUIPPRO
        AND  DTINVIGCNFEP <= P_DTCALEABAS;

      V_CTDIASAGRUP := 0;
      IF V_IDAGRUPPLANO = 'S' THEN
         V_CTDIASAGRUP := P_DTCALEABAS - V_DTINVIGCNFEP;
      END IF;

      IF (V_IDAGRUPPLANO = 'S') AND (V_CTDIASAGRUP >= 0) AND (V_CTDIASAGRUP < 5) THEN
         OPEN C_ITEMMAPA_1;
      ELSE
         OPEN C_ITEMMAPA_2;
      END IF;

      LOOP
         IF (V_IDAGRUPPLANO = 'S') AND (V_CTDIASAGRUP >= 0) AND (V_CTDIASAGRUP < 5) THEN
            FETCH C_ITEMMAPA_1 INTO V_CDPRODUTO, V_CDITEQUIPPRO, V_QTMAXPROITEP, V_VRPREPITEM, V_VRPREPITEMCL;
            EXIT WHEN C_ITEMMAPA_1%NOTFOUND;
         ELSE
            FETCH C_ITEMMAPA_2 INTO V_CDPRODUTO, V_CDITEQUIPPRO, V_QTMAXPROITEP, V_VRPREPITEM, V_VRPREPITEMCL;
            EXIT WHEN C_ITEMMAPA_2%NOTFOUND;
         END IF;

         IF (V_VRPREPITEM+V_VRPREPITEMCL) = 0 THEN
            PRECO_PRODUTO(P_CDEQUIPPRO,V_CDPRODUTO,P_DTCALEABAS,V_VRPRITEMMAP,V_VRPRITEMCMAP,V_POSSUIPRECO);
         ELSE
            V_VRPRITEMMAP  := V_VRPREPITEM;
            V_VRPRITEMCMAP := V_VRPREPITEMCL;
         END IF;

         IF (V_POSSUIPRECO = 'N') THEN
            P_MSGCODIGO  := '3';  /* EXISTE PRODUTO SEM PREO OU COM PREO ZERO.*/
            P_MSGPRODUTO := V_CDPRODUTO;
         END IF;

         /* SOL 15302 - JOGAR A QTDE. MAXIMA NO CAMPO FALTA REPOR SE PARAMETRO = '2'*/
         IF (V_IDTPAPUMAPA = '2') AND (V_IDTPLEIVENDA = '1') THEN
           V_QTFREPITMAPA  := V_QTMAXPROITEP;
         ELSE
           V_QTFREPITMAPA  := 0;
         END IF;

         SELECT COUNT(*)
         INTO   V_EXISTE_MOLA
         FROM   ITEMAPABASEV
         WHERE  CDFILIAL    = P_CDFILIPROC
            AND NRMAPABASEV = P_NRMAPABASEV
            AND CDITMAPABAS = V_CDITEQUIPPRO;

         IF V_EXISTE_MOLA > 0 THEN

            V_INSERE_ITEM := 'NAO';
            /* TESTA SE  O MESMO PRODUTO PARA A MESMA MOLA */
            SELECT COUNT(*)
            INTO   V_EXISTE_PROD
            FROM   ITEMAPABASEV
            WHERE  CDFILIAL    = P_CDFILIPROC
               AND NRMAPABASEV = P_NRMAPABASEV
               AND CDITMAPABAS = V_CDITEQUIPPRO
               AND CDPRODUTO   = V_CDPRODUTO;

            /* SE MUDOU O PRODUTO DA MOLA */
            IF V_EXISTE_PROD = 0 THEN
               V_CDITEQUIPPRO := 'S'||LPAD(V_CONTADOR,9,'0');
               V_CONTADOR     := V_CONTADOR + 1;
               V_INSERE_ITEM  := 'SIM';
            END IF;
         ELSE
            V_INSERE_ITEM := 'SIM';
         END IF;

         IF V_INSERE_ITEM = 'SIM' then
            INSERT INTO ITEMAPABASEV
              (CDFILIAL, NRMAPABASEV, CDITMAPABAS, CDPRODUTO, CDPRODORIGTR, VRPRITEMMAP,
               VRPRITEMCMAP, QTMAXPROITMA,QTFREPITMAPA)
            VALUES
              (P_CDFILIPROC, P_NRMAPABASEV, V_CDITEQUIPPRO, V_CDPRODUTO, V_CDPRODUTO,
               V_VRPRITEMMAP, V_VRPRITEMCMAP, V_QTMAXPROITEP,V_QTFREPITMAPA);

            V_CONTITEMAPA := V_CONTITEMAPA + 1;

            /*Insere os itens da composicao do produto na RECITEMAPABA */
            INSERE_ITEMPREV(P_CDFILIPROC,'',P_NRMAPABASEV,V_CDPRODUTO,1,'M',NULL);

            /*Busca a quantidade da tabela de demanda por equipamento*/
            SELECT COUNT(*) INTO V_EXISTE
            FROM   PREVENDAEQU
            WHERE  CDFILIALCLIE     = P_CDFILIALCLIE
              AND  CDCLIENTE        = P_CDCLIENTE
              AND  CDEQUIPPRO       = P_CDEQUIPPRO
              AND  DTPREVENDEQU     = P_DTCALEABAS
              AND  CDPRODUTO        = V_CDPRODUTO;

            IF V_EXISTE > 0 THEN
               SELECT NVL(QTSOLVENDEQU,0)
               INTO   V_QTPREV
               FROM   PREVENDAEQU
               WHERE  CDFILIALCLIE = P_CDFILIALCLIE
                 AND  CDCLIENTE    = P_CDCLIENTE
                 AND  CDEQUIPPRO   = P_CDEQUIPPRO
                 AND  DTPREVENDEQU = P_DTCALEABAS
                 AND  CDPRODUTO    = V_CDPRODUTO;

               /*Insere os itens da previso de abastecimento */
               IF V_QTPREV < 0 THEN
                  V_QTPREV := 0;
               END IF;
               INSERE_ITEMPREV(P_CDFILIPROC, V_NRPREVABASEV,P_NRMAPABASEV,V_CDPRODUTO,V_QTPREV,'P',NULL);
               V_CONTPREV := V_CONTPREV + 1;
            ELSE
               INSERE_ITEMPREV(P_CDFILIPROC, V_NRPREVABASEV,P_NRMAPABASEV,V_CDPRODUTO,0,'P',NULL);
               V_CONTPREV := V_CONTPREV + 1;
               /*P_MSGCODIGO  := '2';  NAO EXISTE DEMANDA PARA ESTE PRODUTO
               P_MSGMAQUINA := C_MAPAS.CDEQUIPPRO;
               P_MSGDATA    := C_MAPAS.DTCALEABAS;
               P_MSGPRODUTO := V_CDPRODUTO;
               EXIT;*/
            END IF;
         END IF;
      END LOOP;

      /* SE EXISTE PRODUTOS NO PLANOGRAMA */
      IF V_CONTITEMAPA > 0 THEN
         /*raise_application_error(-20501, 'PASSEI AQUI 1'||'-'||V_CDMOEDEIRO , True);*/
         IF P_CDMOEDEIRO <> ' ' THEN

            GERA_SOLICTROCO(P_CDFILIPROC, P_NRSOLICTROCO, P_DTCALEABAS,
                            P_CDROTATRANS, P_NRMAPABASEV, P_CDMOEDEIRO);

            UPDATE MAPABASEV
            SET IDSITTROABAS = '1'
            WHERE CDFILIAL    = P_CDFILIPROC AND
                  NRMAPABASEV = P_NRMAPABASEV;
         END IF;

         /* AGRUPA ITENS DA PREVISAO NA ITPREVABEV */
         FOR C_ITENS IN
           (SELECT IT.CDFILIAL,IT.NRPREVABASEV,IT.CDPRODUTO,
                   SUM(IT.QTITPRABAMAP) AS QUANTIDADE
            FROM   ITPREVABAMAP IT, MAPABASEV MP
            WHERE  MP.CDFILIAL     = P_CDFILIPROC
              AND  MP.CDROTATRANS  = P_CDROTATRANS
              AND  MP.DTMAPABASEV  = P_DTCALEABAS
              AND  MP.CDFILIALCLIE = P_CDFILIALCLIE
              AND  MP.NRMAPABASEV  = P_NRMAPABASEV
              AND  MP.CDFILIAL     = IT.CDFILIAL
              AND  MP.NRMAPABASEV  = IT.NRMAPABASEV
            GROUP BY IT.CDFILIAL,IT.NRPREVABASEV,IT.CDPRODUTO) LOOP

            SELECT COUNT(*)
            INTO   V_EXISTE_PREV
            FROM   PREVABASEV PR, ITPREVABASEV IT
            WHERE  PR.CDFILIAL     = P_CDFILIPROC
              AND  PR.DTPREVABASEV = P_DTCALEABAS
              AND  PR.CDROTATRANS  = P_CDROTATRANS
              AND  PR.CDFILIALCLIE = P_CDFILIALCLIE
              AND  IT.CDFILIAL     = PR.CDFILIAL
              AND  IT.NRPREVABASEV = PR.NRPREVABASEV
              AND  IT.CDPRODUTO    = C_ITENS.CDPRODUTO
              AND  IT.NRPREVABASEV = C_ITENS.NRPREVABASEV;

            IF V_EXISTE_PREV = 0 THEN
               INSERT INTO ITPREVABASEV
                (CDFILIAL,NRPREVABASEV,CDPRODUTO,QTITPRABASEV,QTITSOABASEV,IDTPLANPRABA)
               VALUES
                (C_ITENS.CDFILIAL,C_ITENS.NRPREVABASEV,C_ITENS.CDPRODUTO,C_ITENS.QUANTIDADE,C_ITENS.QUANTIDADE,'A');
            ELSE
               UPDATE ITPREVABASEV
               SET    QTITPRABASEV = QTITPRABASEV + C_ITENS.QUANTIDADE,
                      QTITSOABASEV = QTITSOABASEV + C_ITENS.QUANTIDADE
               WHERE  CDFILIAL     = C_ITENS.CDFILIAL
                 AND  NRPREVABASEV = C_ITENS.NRPREVABASEV
                 AND  CDPRODUTO    = C_ITENS.CDPRODUTO;
            END IF;
         END LOOP;
      END IF;
      IF V_CONTITEMAPA <= 0 THEN
         P_MSGCODIGO  := '4';  /* EQUIPAMENTO SEM PRODUTOS NO PLANOGRAMA PRINCIPAL */
      END IF;
   ELSE
      IF V_EXISTE_VENDA > 0 THEN
         P_MSGCODIGO  := '5';  /* EQUIPAMENTO COM VENDA J GERADO PARA PERIODO DA FRENTE */
      END IF;
      IF V_EXISTE_PARAM = 0 THEN
         P_MSGCODIGO  := '6';  /* EQUIPAMENTO COM DOIS MAPAS GERADOS PARA A MESMA DATA */
      END IF;
      IF V_EXISTE_MAPA > 0 THEN
         P_MSGCODIGO  := '1';  /* EQUIPAMENTO COM DOIS MAPAS GERADOS PARA A MESMA DATA */
      END IF;
   END IF;
END;
/
